!*****************************************************************************!
!* 
!*      $RCSfile: CloseEuler2D.f90,v $
!*
!*      $Revision: 1.3 $
!*
!*      $Date: 2004/02/09 11:57:22 $
!*
!*      $Author: roller $
!*
!*****************************************************************************!

MODULE CloseEuler2D_mod
  !---------------------------------------------------------------------------!
  IMPLICIT NONE
  PRIVATE
  !---------------------------------------------------------------------------!
  INTERFACE CloseEuler2D
     MODULE PROCEDURE CloseEuler2D
  END INTERFACE
  !---------------------------------------------------------------------------!
  PUBLIC  :: CloseEuler2D
  !---------------------------------------------------------------------------!

CONTAINS

  SUBROUTINE CloseEuler2D(pvar,cvar,Mesh,MPI)
    USE Types
    !---------------------------------------------------------------------------!
    IMPLICIT NONE
    !---------------------------------------------------------------------------!
    ! Argument list declaration
    TYPE(tMesh)             :: Mesh
    TYPE(tMPI)              :: MPI
    REAL, POINTER           :: pvar(:,:,:)
    REAL, POINTER           :: cvar(:,:,:)
    ! Local variable declaration
    INTEGER                 :: allocStat
    !---------------------------------------------------------------------------!
    
    DEALLOCATE(pvar,cvar,Mesh%Bary,Mesh%Surface,STAT=allocStat)

    IF(allocStat.NE.0) THEN
       PRINT *, 'ERROR CloseEuler2D : Cannot deallocate! '
       STOP
    ENDIF

    if (MPI%myrank == 0) then
       WRITE(*,*) '=============== Program terminated correctly ================== '
    endif

  END SUBROUTINE CloseEuler2D


END MODULE CloseEuler2D_mod
