!*****************************************************************************!
!* 
!*      $RCSfile: PrimConsLR.f90,v $
!*
!*      $Revision: 1.2 $
!*
!*      $Date: 2003/12/11 14:46:59 $
!*
!*      $Author: roller $
!*
!*****************************************************************************!

MODULE PrimConsLR_mod
  !---------------------------------------------------------------------------!
  IMPLICIT NONE
  PRIVATE
  !---------------------------------------------------------------------------!
  INTERFACE PrimconsLR
     MODULE PROCEDURE PrimconsLR
  END INTERFACE
  !---------------------------------------------------------------------------!
  PUBLIC  :: PrimconsLR
  !---------------------------------------------------------------------------!

CONTAINS

  SUBROUTINE PrimconsLR(iflag,state,cons,Const,Mesh)
    USE Types
    !---------------------------------------------------------------------------!
    IMPLICIT NONE
    !---------------------------------------------------------------------------!
    ! Argument list declaration
    TYPE(tConstants)        :: Const
    TYPE(tMesh)             :: Mesh
    INTEGER                 :: iflag
    REAL                    :: state(2,0:Mesh%IMAX+1,0:Mesh%JMAX+1,Const%nvar)
    REAL                    :: cons(2,0:Mesh%IMAX+1,0:Mesh%JMAX+1,Const%nvar)
    ! Local variable declaration
    REAL                    :: gamm1, gamma1q
    !---------------------------------------------------------------------------!
    INTENT(IN)              :: iflag, Const, Mesh
    INTENT(INOUT)             :: state, cons
    !---------------------------------------------------------------------------!

    gamm1   = Const%gamma - 1.0
    gamma1q = 1.0 / gamm1

    SELECT CASE(iflag)
    CASE(1)                    ! (1) conservative to primitive transformation
       
       state(:,:,:,1) =                                     ! density (rho)
       state(:,:,:,2) =                                     ! x-velocity (u)
       state(:,:,:,3) =                                     ! y-velocity (v)
       state(:,:,:,4) = 

                                                         ! pressure (p)
       
       ! check if density and pressure are negative
       WHERE ( state(:,:,:,1) < 1.e-10 )
          state(:,:,:,1) = 1.e-10
       END WHERE
       WHERE ( state(:,:,:,4) < 1.e-10 )
          state(:,:,:,4) = 1.e-10
       END WHERE
       
       
    CASE(2)                    ! (2) primitive to conservative transformation
       
       cons(:,:,:,1) =                                      ! density
       cons(:,:,:,2) =                                      ! x-momentum
       cons(:,:,:,3) =                                      ! y-momentum
       cons(:,:,:,4) = 

                                                            ! total energy
       
    CASE DEFAULT
    
       PRINT *, 'ERROR PrimconsLR : Wrong direction flag for conversion.  '
       PRINT *, 'Use (1) for cons -> prim and (2) for prim -> cons.     '
       STOP
   
    END SELECT
    
  END SUBROUTINE PrimconsLR


END MODULE PrimconsLR_mod
