!*****************************************************************************!
!* 
!*      $RCSfile: Limiter.f90,v $
!*
!*      $Revision: 1.2 $
!*
!*      $Date: 2003/01/23 12:36:50 $
!*
!*      $Author: roller $
!*
!*****************************************************************************!

MODULE Limiter_mod
  !---------------------------------------------------------------------------!
  IMPLICIT NONE
  PRIVATE
  !---------------------------------------------------------------------------!
  INTERFACE Minmod
     MODULE PROCEDURE Minmod
  END INTERFACE
  !---------------------------------------------------------------------------!
  PUBLIC  :: Minmod
  !---------------------------------------------------------------------------!

CONTAINS

  SUBROUTINE minmod(slope1,slope2,limslope,Const)
    USE Types
    !---------------------------------------------------------------------------!
    IMPLICIT NONE
    !---------------------------------------------------------------------------!
    ! Argument list declaration
    TYPE(tConstants)        :: Const
    REAL                    :: slope1(Const%nvar), slope2(Const%nvar)
    REAL                    :: limslope(Const%nvar)
    ! Local variable declaration
    INTEGER                 :: k
    !---------------------------------------------------------------------------!
    INTENT(IN)              :: slope1, slope2, Const
    INTENT(OUT)             :: limslope
    !---------------------------------------------------------------------------!

    DO k=1,Const%nvar
       IF((slope1(k)*slope2(k)).GE.0) THEN
          limslope(k)=sign(1.,slope1(k))*min(abs(slope1(k)),abs(slope2(k)))
       ELSE
          limslope(k)=0.
       ENDIF
    ENDDO
    
  END SUBROUTINE minmod

END MODULE Limiter_mod
